/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
#ifndef OS_WIN32
#include <config.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <GL/glut.h>
#include <GL/gl.h>
#include "wuerfel.h"

void
WglKey (unsigned char key, int x, int y) {
    switch (key) {
    case 27: /* ESC */
    case 'q':
	exit (1);
    case '1':
    case '2':
    case '3':
	WglSubMenuModus ((int)(key - '0'));
        break;
    case '.':
	WglNextPos ();
	break;
    case ',':
	WglPrevPos ();
	break;
    case 'g':
	WglToggleGitterFlaechen ();
	break;
    case 'a':
	WglToggleAchsen ();
	break;
    case 'e':
	WglToggleVirtuell ();
	break;
    case 'h':
    case 'i':
	glutSetWindow (winIdSub);
	if (options.info) {
	    glutHideWindow();
	}
	else {
	    glutShowWindow();
	}
	options.info = !options.info;
	break;
    case 'k':
        if (options.kuboid) {
	  options.kuboid = !options.kuboid;
	  WglCreateDisplayLists ();
	}
	else if (options.oloid) {
	  options.oloid = FALSE;
	  options.kuboid = TRUE;
	  WglCreateDisplayLists ();
	}
	break;
    case 'o':
        if (options.oloid) {
	  options.oloid = !options.oloid;
	  WglCreateDisplayLists ();
	}
	else if (options.kuboid) {
	  options.kuboid = FALSE;
	  options.oloid = TRUE;
	  WglCreateDisplayLists ();
	}
	break;
    case 'p':
	WglTogglePerspektive ();
	break;
    case 's':
	halt = !halt;
	break;
    case 't':
	WglToggleTorkeln ();
	break;
    case 'x':
	rotx += 1.;
	break;
    case 'y':
	roty += 1.;
	break;
    case 'z':
	rotz += 1.;
	break;
    case '+':
	WglSubMenuSpeed (1);
	break;
    case '-':
	WglSubMenuSpeed (2);
	break;
    case 'l':
	options.labels = !options.labels;
	WglCreateDisplayLists ();
	break;
    case 'w':
	options.wuerfel = !options.wuerfel;
	break;
    default:
	return;
    }
    WglPostRedisplay ();
}

void
WglSpecialKey (int key, int x, int y) {
    switch (key) {
    case GLUT_KEY_UP:
	trany += 0.1;
	break;
    case GLUT_KEY_DOWN:
	trany -= 0.1;
	break;
    case GLUT_KEY_LEFT:
	tranx -= 0.1;
	break;
    case GLUT_KEY_RIGHT:
	tranx += 0.1;
	break;
    case GLUT_KEY_PAGE_UP:
	tranz += 0.1;
	break;
    case GLUT_KEY_PAGE_DOWN:
	tranz -= 0.1;
	break;
    case GLUT_KEY_HOME:
	rotx = roty = rotz = tranx = trany = tranz = 0.;
	drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
	break;
    default:
	return;
    }
    WglPostRedisplay ();
}

void
WglCreateMenus (void) {
    /* Modus-Submenue */
    menIdMainSubModus = glutCreateMenu (WglSubMenuModus);
    glutAddMenuEntry ("<1> Hauptdiagonale fixiert", 1);
    glutAddMenuEntry ("<2> Scharnierkante fixiert", 2);
    glutAddMenuEntry ("<3> Element fixiert", 3);

    /* Geschwindigkeit-Submenue */
    menIdMainSubSpeed = glutCreateMenu (WglSubMenuSpeed);
    glutAddMenuEntry ("<+> Schneller", 1);
    glutAddMenuEntry ("<-> Langsamer", 2);

    /* Create main menu for main window */
    menIdMain = glutCreateMenu (WglMainMenu);
    if (options.tork) {
        glutAddMenuEntry ("<t> Schweben aus", 1);
    }
    else {
        glutAddMenuEntry ("<t> Schweben ein", 1);
    }
    if (options.ei) {
        glutAddMenuEntry ("<e> Virtuelle Ecken aus", 2);
    }
    else {
        glutAddMenuEntry ("<e> Virtuelle Ecken ein", 2);
    }
    if (options.ach) {
        glutAddMenuEntry ("<a> Achsen aus", 3);
    }
    else {
        glutAddMenuEntry ("<a> Achsen ein", 3);
    }
    glutAddMenuEntry ("<p> Projektion orthogonal", 4);
    glutAddMenuEntry ("<g> Gitter", 5);
    if (options.labels) {
        glutAddMenuEntry ("<l> Labels aus", 6);
    }
    else {
        glutAddMenuEntry ("<l> Labels ein", 6);
    }
    if (options.kuboid) {
        glutAddMenuEntry ("<k> Kuboid aus", 7);
    }
    else {
        glutAddMenuEntry ("<k> Kuboid ein", 7);
    }
    if (options.oloid) {
        glutAddMenuEntry ("<o> Oloid aus", 8);
    }
    else {
        glutAddMenuEntry ("<o> Oloid ein", 8);
    }
    if (options.wuerfel) {
        glutAddMenuEntry ("<w> Wuerfelguertel aus", 9);
    }
    else {
        glutAddMenuEntry ("<w> Wuerfelguertel ein", 9);
    }
    glutAddSubMenu ("Geschwindigkeit", menIdMainSubSpeed);
    glutAddSubMenu ("Modus", menIdMainSubModus);
    glutAddMenuEntry ("<q> Ende", 10);
    glutAttachMenu (GLUT_RIGHT_BUTTON);
}

void
WglSubMenuModus (int value) {
    switch (value) {
    case 1:
    case 2:
    case 3:
	options.mode = value;
	break;
    }
}

void
WglSubMenuSpeed (int value) {
    switch (value) {
    case 1:
	waittime.tv_usec /= 2;
	break;
    case 2:
	waittime.tv_usec *= 2;
	if (waittime.tv_usec == 0) {waittime.tv_usec = 1;}
	break;
    }
}

void
WglMainMenu(int value){

    switch(value){

    case 1:
	WglToggleTorkeln ();
	break;

    case 2:
	WglToggleVirtuell ();
	break;

    case 3:
	WglToggleAchsen ();
	break;

    case 4:
	WglTogglePerspektive ();
	break;

    case 5:
	WglToggleGitterFlaechen ();
	break;

    case 6:
	WglToggleLabels ();
	break;

    case 7:
	WglToggleKuboid ();
	break;

    case 8:
	WglToggleOloid ();
	break;

    case 9:
	WglToggleWuerfelguertel ();
	break;

    case 10:
	WglExit ();
	break;
    }
}

void
WglToggleTorkeln (void) {
      if(options.tork) {
	  glutChangeToMenuEntry(1, "<t> Schweben Ein", 1);
      }
      else {
	  glutChangeToMenuEntry(1, "<t> Schweben Aus", 1);
      }
      options.tork = ! options.tork;
}

void
WglToggleVirtuell (void) {
      if(options.ei) {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken Ein", 2);
      }
      else {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken Aus", 2);
      }
      options.ei = ! options.ei;
}

void
WglToggleAchsen (void) {
      if(options.ach) {
	  glutChangeToMenuEntry(3, "<a> Achsen Ein", 3);
      }
      else {
	  glutChangeToMenuEntry(3, "<a> Achsen Aus", 3);
      }
      options.ach = ! options.ach;
}

void
WglTogglePerspektive (void) {
      if(options.perspektive) {
	  glutChangeToMenuEntry(4, "<p> Projektion perspektivisch", 4);
      }
      else {
	  glutChangeToMenuEntry(4, "<p> Projektion orthogonal", 4);
      }
      options.perspektive = ! options.perspektive;
      WglReshape (options.seite, options.seite);
}

void
WglToggleGitterFlaechen (void) {
      if(options.lines) {
	  glutChangeToMenuEntry(5, "<g> Gitter", 5);
      }
      else {
	  glutChangeToMenuEntry(5, "<g> Flaechen", 5);
      }
      options.lines = ! options.lines;
      if (polygonMode == GL_LINE) {
	  polygonMode = GL_FILL;
      }
      else {
	  polygonMode = GL_LINE;
      }
      glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
}

void
WglToggleLabels (void) {
      if(options.labels) {
	  glutChangeToMenuEntry(6, "<l> Labels Ein", 6);
      }
      else {
	  glutChangeToMenuEntry(6, "<l> Labels Aus", 6);
      }
      options.labels = ! options.labels;
      WglCreateDisplayLists ();
}

void
WglToggleKuboid (void) {
      if(options.kuboid) {
	  glutChangeToMenuEntry(7, "<k> Kuboid Ein", 6);
      }
      else {
	  glutChangeToMenuEntry(7, "<k> Kuboid Aus", 6);
      }
      options.kuboid = ! options.kuboid;
      WglCreateDisplayLists ();
}

void
WglToggleOloid (void) {
      if(options.oloid) {
	  glutChangeToMenuEntry(8, "<o> Oloid Ein", 6);
      }
      else {
	  glutChangeToMenuEntry(8, "<o> Oloid Aus", 6);
      }
      options.oloid = ! options.oloid;
      WglCreateDisplayLists ();
}

void
WglToggleWuerfelguertel (void) {
      if(options.wuerfel) {
	  glutChangeToMenuEntry(9, "<w> Wuerfelguertel Ein", 6);
      }
      else {
	  glutChangeToMenuEntry(9, "<o> Wuerfelguertel Aus", 6);
      }
      options.wuerfel = ! options.wuerfel;
}

void
WglExit (void) {
    exit (1);
}
